package com.bureau.base.compose

import androidx.compose.runtime.Composable
import androidx.compose.runtime.LaunchedEffect
import androidx.lifecycle.LifecycleOwner
import com.bureau.base.extensions.rememberFlowWithLifecycle
import kotlinx.coroutines.flow.Flow

@Composable
fun <ViewSideEffect> SideEffects(
    sideEffectFlow: Flow<ViewSideEffect>,
    lifecycleOwner: LifecycleOwner,
    processSideEffect: (ViewSideEffect) -> Unit
) {
    val effectFlowLifecycleAware = rememberFlowWithLifecycle(flow = sideEffectFlow, lifecycleOwner)

    LaunchedEffect(
        key1 = sideEffectFlow,
        key2 = lifecycleOwner
    ) {
        effectFlowLifecycleAware.collect { effect ->
            processSideEffect(effect)
        }
    }
}
